### org.jfree.layouting.renderer

# Interface Renderer

All Superinterfaces:
  StatefullComponent

Known Implementing Classes:
  AbstractRenderer, ChainingRenderer, PaginatingRenderer, PrintingRenderer, PrototypeBuildingRenderer, StreamingRenderer

`public interface Renderer`
`extends StatefullComponent`

The renderer is the last step in the predefined processing chain. The renderer computes the layout according to the style rules given in the elements and the inherent limitations of the output targets.

Renderers depend heavily on a correct input model - at this point no model transformation should be done at all (except, maybe, inserting new lineboxes where needed).

Contents for the page or special areas (@footnote, @endnote) are forwarded immediatly.

Author:
  Thomas Morgner

  ## Method Summary

  `void`

  `addContent(LayoutContext context, ContentToken content)`

  `void`

  `addPassThroughContent(LayoutContext context, ContentToken content)`

  `void`

  `finishedBlock()`

  `void`

  `finishedDocument()`

  `void`

  `finishedFlow()`

  `void`

  `finishedInline()`

  `void`

  `finishedMarker()`

  `void`

  `finishedPassThrough()`

  `void`

  `finishedRootInline()`

  `void`

  `finishedTable()`

  `void`

  `finishedTableCaption()`

  `void`

  `finishedTableCell()`

  `void`

  `finishedTableColumn()`

  `void`

  `finishedTableColumnGroup()`

  `void`

  `finishedTableRow()`

  `void`

  `finishedTableSection()`

  `void`

  `handlePageBreak(PageContext pageContext)`
    A call-back that informs the renderer, that a new page must be started.

  `void`

  `startedBlock(LayoutContext context)`

  `void`

  `startedDocument(PageContext pageContext)`
    Starts the document and initalizes the default page context.

  `void`

  `startedFlow(LayoutContext context)`
    Starts a floating, absolute or static element.

  `void`

  `startedInline(LayoutContext context)`

  `void`

  `startedMarker(LayoutContext context)`

  `void`

  `startedPassThrough(LayoutContext context)`

  `void`

  `startedRootInline(LayoutContext context)`

  `void`

  `startedTable(LayoutContext layoutContext)`

  `void`

  `startedTableCaption(LayoutContext context)`

  `void`

  `startedTableCell(LayoutContext layoutContext)`

  `void`

  `startedTableColumn(LayoutContext context)`

  `void`

  `startedTableColumnGroup(LayoutContext context)`

  `void`

  `startedTableRow(LayoutContext layoutContext)`

  `void`

  `startedTableSection(LayoutContext layoutContext)`

  ### Methods inherited from interface org.jfree.layouting.StatefullComponent

  `saveState`

## Method Details

### addContent

    public void addContent(LayoutContext context,
                           ContentToken content)
                throws NormalizationException

### addPassThroughContent

    public void addPassThroughContent(LayoutContext context,
                                      ContentToken content)
                throws NormalizationException

### finishedBlock

    public void finishedBlock()
                throws NormalizationException

### finishedDocument

    public void finishedDocument()
                throws NormalizationException

### finishedFlow

    public void finishedFlow()
                throws NormalizationException

### finishedInline

    public void finishedInline()
                throws NormalizationException

### finishedMarker

    public void finishedMarker()
                throws NormalizationException

### finishedPassThrough

    public void finishedPassThrough()
                throws NormalizationException

### finishedRootInline

    public void finishedRootInline()
                throws NormalizationException

### finishedTable

    public void finishedTable()
                throws NormalizationException

### finishedTableCaption

    public void finishedTableCaption()
                throws NormalizationException

### finishedTableCell

    public void finishedTableCell()
                throws NormalizationException

### finishedTableColumn

    public void finishedTableColumn()
                throws NormalizationException

### finishedTableColumnGroup

    public void finishedTableColumnGroup()
                throws NormalizationException

### finishedTableRow

    public void finishedTableRow()
                throws NormalizationException

### finishedTableSection

    public void finishedTableSection()
                throws NormalizationException

### handlePageBreak

    public void handlePageBreak(PageContext pageContext)

> A call-back that informs the renderer, that a new page must be started. This closes the old page context and copies all pending content to the new context.

> This method is triggered by a call to 'LayoutProcess.pageBreakEncountered'
> Parameters:
>   `pageContext` -

### startedBlock

    public void startedBlock(LayoutContext context)
                throws NormalizationException

### startedDocument

    public void startedDocument(PageContext pageContext)

> Starts the document and initalizes the default page context.
> Parameters:
>   `pageContext` -

### startedFlow

    public void startedFlow(LayoutContext context)
                throws NormalizationException

> Starts a floating, absolute or static element. This establishes a new normal flow for the element.
> Parameters:
>   `context` -

### startedInline

    public void startedInline(LayoutContext context)
                throws NormalizationException

### startedMarker

    public void startedMarker(LayoutContext context)
                throws NormalizationException

### startedPassThrough

    public void startedPassThrough(LayoutContext context)
                throws NormalizationException

### startedRootInline

    public void startedRootInline(LayoutContext context)
                throws NormalizationException

### startedTable

    public void startedTable(LayoutContext layoutContext)
                throws NormalizationException

### startedTableCaption

    public void startedTableCaption(LayoutContext context)
                throws NormalizationException

### startedTableCell

    public void startedTableCell(LayoutContext layoutContext)
                throws NormalizationException

### startedTableColumn

    public void startedTableColumn(LayoutContext context)
                throws NormalizationException

### startedTableColumnGroup

    public void startedTableColumnGroup(LayoutContext context)
                throws NormalizationException

### startedTableRow

    public void startedTableRow(LayoutContext layoutContext)
                throws NormalizationException

### startedTableSection

    public void startedTableSection(LayoutContext layoutContext)
                throws NormalizationException